﻿using Dicom.Network;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reactive.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DicomClient = Dicom.Network.Client.DicomClient;

namespace C_UI
{
    public static class SCU_Store
    {
        public static async Task StoreFile(string _storeServerHost, int _storeServerPort, string[] dicomFiles, string _aet, string _storeServerAET)
        {
            var client = new DicomClient(_storeServerHost, _storeServerPort, false, _storeServerAET, _aet);
            client.NegotiateAsyncOps();
            
            dicomFiles.ToObservable().Subscribe(async currentFile =>
            {
                try
                {
                    var request = new DicomCStoreRequest(currentFile.ToString());
                    request.OnResponseReceived += (req, response) => Console.WriteLine("C-Store Response Received, Status: " + response.Status);
                    await client.AddRequestAsync(request);
                    await client.SendAsync();

                }
                catch (Exception exception)
                {
                    MessageBox.Show(exception.Message);
                }
            });

        }
    }
}
